' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2010                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -----------------------------------------------------------------
' FVIL Sample Program
' C_CAO
'
' 쐬 : N.Moriguchi
'
'  : 2011/01/28 
'
' FV-GP440 4ch only Sample Program
' -----------------------------------------------------------------
Public Class Form_FVGP440_4CHSAMPLE

    Private m_image As List(Of FVIL.Data.CFviImage) = New List(Of FVIL.Data.CFviImage)              '摜i[̈
    Private m_video As List(Of FVIL.Video.CFviVideoGP440) = New List(Of FVIL.Video.CFviVideoGP440)  'FV-GP440NX
    Private m_timer As FVIL.CFviTimeCounter = New FVIL.CFviTimeCounter()                            'ԌvNX

    Dim intErr(3) As Integer                                                                        'G[ԍi[ϐ
    Public m_strIniFilePath As String                                                               'init@CitpXj

    Private m_flgVideoOpened(3) As Boolean                                                          'rfIfoCX̃I[v
    Private m_flgFreerun As Boolean                                                                 't[̏

    Private Sub FormMainLoad(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'FVIL̏
        'AvP[VNA ̊֐ĂяoăCuĂB 
        '̎ACZX̔F؂s܂BpԒłĂȀ͕KsKvL܂B 
        'sȂꍇ́AveNgꂽNX̎sł܂B
        FVIL._SetUp.InitVisionLibrary()

        'ԕϐ̏
        For Num As Integer = 0 To 3
            m_flgVideoOpened(Num) = False
            m_image.Add(New FVIL.Data.CFviImage())
            m_video.Add(New FVIL.Video.CFviVideoGP440)
        Next
        m_flgFreerun = False

        'vԃeLXg{bNX
        TextBoxTime.Text = "0"

        'gK[hR{{bNX
        ComboBoxTrigger.Items.Clear()
        ComboBoxTrigger.Items.Add("gK")
        ComboBoxTrigger.Items.Add("OgK")
        ComboBoxTrigger.SelectedIndex = 0

        'QlR{{bNX
        ComboBoxBinarize.Items.Clear()
        ComboBoxBinarize.Items.Add("OC")
        ComboBoxBinarize.Items.Add("l")
        ComboBoxBinarize.SelectedIndex = 0

    End Sub

    ''' <summary>
    ''' tH[\Jn Cxgnh
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' gpmF܂B
    ''' </remarks>
    Private Sub formMain_Shown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Shown
        'gp̊mF
        Dim licence_dialog As New dialogLicence
        If (licence_dialog.ShowDialog(Me) <> Windows.Forms.DialogResult.OK) Then
            Me.Close() 'gpȂꍇ̓TvvO̓I
            Exit Sub
        End If

        'init@CI
        fnSetIniFile()

        '`imagẽZbg
        CFviImageViewCH0.Image = m_image(0)
        CFviImageViewCH1.Image = m_image(1)
        CFviImageViewCH2.Image = m_image(2)
        CFviImageViewCH3.Image = m_image(3)

    End Sub

    ''' <summary>
    ''' I
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' AvP[VIB
    ''' </remarks>
    Private Sub FormMainFormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        'rfIfoCXI[vĂꍇ̓N[Y
        For Num As Integer = 0 To 3
            If (m_video(Num).IsOpen = True) Then
                m_video(Num).Close()
                m_flgVideoOpened(Num) = False
            End If
        Next
    End Sub

    ''' <summary>
    ''' init@CI֐
    ''' </summary>
    ''' <remarks>
    ''' init@C̑I܂B
    ''' </remarks>
    Private Sub fnSetIniFile()
        Dim formbroseini As New Form_BROWSEINI  'init@Cݒ
        Dim Num As Integer

        'init@C̑I
        m_strIniFilePath = ""
        If (Form_BROWSEINI.ShowDialog(Me) = Windows.Forms.DialogResult.OK) Then
            m_strIniFilePath = Form_BROWSEINI.strIniFilePath
        End If

        If (m_strIniFilePath.Length > 0) Then
            Try
                'rfIfoCXI[vĂꍇ̓N[Y
                For Num = 0 To 3
                    If (m_video(Num).IsOpen = True) Then
                        m_video(Num).Close()
                        m_flgVideoOpened(Num) = False
                    End If
                Next

                'foCXI[v
                Dim open_ch As Integer
                For Num = 0 To 3
                    open_ch = 1 << Num
                    If (Form_BROWSEINI.SelectChannelNo And open_ch) Then
                        m_video(Num).Open(-1, Num)
                        m_flgVideoOpened(Num) = True
                    End If
                Next

                For Num = 0 To 3
                    If (m_flgVideoOpened(Num) = True) Then
                        'init@CR|[lgɐݒ
                        m_video(Num).LoadIniFile(m_strIniFilePath)
                    End If
                Next

                'VideoConfFile̕ύXAOpenDevicesƁAgK[[h̕ύX܂
                'ЃLv`{[h̓gK[[h̐ݒɃZbgAbv^CKvɂȂ܂
                '{vÕZbgAbv^C͕Kvőlł350msݒ肵Ă܂B
                'Lv`{[hɂĂ̎Ԃ͈قȂ܂B
                Threading.Thread.Sleep(350)

                'Xe[^X\̍XV
                'e`l̃Xe[^X擾
                If (m_flgVideoOpened(0) = True) Then
                    'JIԂ̎擾
                    NumericUpDownCH0Exposure.Value = m_video(0).ExposureTime
                    'rfI̓ItZbg̎擾
                    NumericUpDownCH0Offset.Value = m_video(0).VideoOffset
                    'Ql臒l̎擾
                    NumericUpDownCH0Threshold.Value = m_video(0).Binarize.Threshold
                End If
                If (m_flgVideoOpened(1) = True) Then
                    'JIԂ̎擾
                    NumericUpDownCH1Exposure.Value = m_video(1).ExposureTime
                    'rfI̓ItZbg̎擾
                    NumericUpDownCH1Offset.Value = m_video(1).VideoOffset
                    'Ql臒l̎擾
                    NumericUpDownCH1Threshold.Value = m_video(1).Binarize.Threshold
                End If
                If (m_flgVideoOpened(2) = True) Then
                    'JIԂ̎擾
                    NumericUpDownCH2Exposure.Value = m_video(2).ExposureTime
                    'rfI̓ItZbg̎擾
                    NumericUpDownCH2Offset.Value = m_video(2).VideoOffset
                    'Ql臒l̎擾
                    NumericUpDownCH2Threshold.Value = m_video(2).Binarize.Threshold
                End If
                If (m_flgVideoOpened(3) = True) Then
                    'JIԂ̎擾
                    NumericUpDownCH3Exposure.Value = m_video(3).ExposureTime
                    'rfI̓ItZbg̎擾
                    NumericUpDownCH3Offset.Value = m_video(3).VideoOffset
                    'Ql臒l̎擾
                    NumericUpDownCH3Threshold.Value = m_video(3).Binarize.Threshold
                End If

                'gKLp[^\
                Dim SimTrigger As FVIL.Video.CFviSimTrigger = New FVIL.Video.CFviSimTrigger
                '2lp[^\
                Dim binarize As FVIL.Video.CFviVideoBinarize = New FVIL.Video.CFviVideoBinarize
                Dim LastCH As Integer

                SimTrigger.SwMode = 1               '\tgEFAgKL
                SimTrigger.ExtMode = 1              'OgKL
                For Num = 0 To 3
                    If (m_flgVideoOpened(Num) = True) Then
                        'gK[h̐ݒ
                        m_video(Num).Trigger = 2    'OgKɂ
                        '荞݂sׁAgKL[hɐݒ
                        m_video(Num).SimTrigger = SimTrigger
                        'Ql[h̐ݒ
                        binarize = m_video(Num).Binarize
                        binarize.Mode = ComboBoxBinarize.SelectedIndex
                        m_video(Num).Binarize = binarize
                        '捞摜𐳋K
                        m_video(Num).ChangeImageSize(m_image(Num))
                        LastCH = Num
                    End If
                Next
                'gKIĂꍇAŌ̃`l̂ݓgKɂB
                If (ComboBoxTrigger.SelectedIndex = 0) Then
                    m_video(LastCH).Trigger = 1         'gKɂ
                End If

                'ЃLv`{[h̓gK[[h̐ݒɃZbgAbv^CKvɂȂ܂
                '{vÕZbgAbv^C͕Kvőlł350msݒ肵Ă܂B
                'Lv`{[hɂĂ̎Ԃ͈قȂ܂B
                Threading.Thread.Sleep(350)
            Catch ex As Exception
                'G[
                For Num = 0 To 3
                    intErr(Num) = m_video(Num).ErrorCode
                Next
                MessageBox.Show("ErrorCode:CH0=" + intErr(0).ToString + ",CH1=" + intErr(1).ToString + ",CH2=" + intErr(2).ToString + ",CH3=" + intErr(3).ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try

        Else
            'init@CȈꍇ̓TvvO̓I
            Me.Close()
            Exit Sub
        End If

    End Sub

    ''' <summary>
    ''' Grab One{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' J荞݁B
    ''' </remarks>
    Private Sub ButtonGrabOne_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonGrabOne.Click
        Dim msec As Double
        Dim Num As Integer

        Try
            'ԑJn
            m_timer.Start()
            For Num = 0 To 3
                If (m_flgVideoOpened(Num) = True) Then
                    'J荞
                    m_video(Num).GrabImageASync(m_image(Num))
                End If
            Next
            For Num = 0 To 3
                If (m_flgVideoOpened(Num) = True) Then
                    '荞݂܂őҋ@
                    m_video(Num).GrabWait()
                End If
            Next
            'ԑI
            msec = m_timer.Stop()
            '莞ԕ\
            TextBoxTime.Text = msec.ToString("0.000")
            'ĕ`
            CFviImageViewCH0.Refresh()
            CFviImageViewCH1.Refresh()
            CFviImageViewCH2.Refresh()
            CFviImageViewCH3.Refresh()
        Catch ex As Exception
            'G[
            For Num = 0 To 3
                If (m_flgVideoOpened(Num) = True) Then
                    intErr(Num) = m_video(Num).ErrorCode
                    '摜荞ݒ~
                    m_video(Num).AbortCapture()
                End If
            Next
            MessageBox.Show("ErrorCode:CH0=" + intErr(0).ToString + ",CH1=" + intErr(1).ToString + ",CH2=" + intErr(2).ToString + ",CH3=" + intErr(3).ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' Grab Continue{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' t[JnE~B
    ''' </remarks>
    Private Sub ButtonGrabContinue_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonGrabContinue.Click
        '{^\ύX
        If (m_flgFreerun = True) Then
            ButtonGrabContinue.Text = "Grab Continue"
            ButtonGrabOne.Enabled = True
            m_flgFreerun = False
            Timer1.Enabled = False
        Else
            ButtonGrabContinue.Text = "Stop"
            ButtonGrabOne.Enabled = False
            m_flgFreerun = True
            Timer1.Interval = 50
            Timer1.Start()
        End If
        Application.DoEvents()

    End Sub

    ''' <summary>
    ''' t[
    ''' </summary>
    ''' <remarks>
    ''' AJ荞݁B
    ''' </remarks>
    Private Sub Timer1Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Dim msec As Double
        Dim Num As Integer

        Timer1.Stop()

        Try
            'ԑJn
            m_timer.Start()
            For Num = 0 To 3
                If (m_flgVideoOpened(Num) = True) Then
                    'J荞
                    m_video(Num).GrabImageASync(m_image(Num))
                End If
            Next
            For Num = 0 To 3
                If (m_flgVideoOpened(Num) = True) Then
                    '荞݂܂őҋ@
                    m_video(Num).GrabWait()
                End If
            Next
            'ԑI
            msec = m_timer.Stop()
            '莞ԕ\
            TextBoxTime.Text = msec.ToString("0.000")
            'ĕ`
            CFviImageViewCH0.Refresh()
            CFviImageViewCH1.Refresh()
            CFviImageViewCH2.Refresh()
            CFviImageViewCH3.Refresh()

            Timer1.Enabled = True
        Catch ex As Exception
            ButtonGrabContinue.Text = "Grab Continue"
            ButtonGrabOne.Enabled = True
            m_flgFreerun = False
            Timer1.Enabled = False

            'G[
            For Num = 0 To 3
                If (m_flgVideoOpened(Num) = True) Then
                    intErr(Num) = m_video(Num).ErrorCode
                    '摜荞ݒ~
                    m_video(Num).AbortCapture()
                End If
            Next
            MessageBox.Show("ErrorCode:CH0=" + intErr(0).ToString + ",CH1=" + intErr(1).ToString + ",CH2=" + intErr(2).ToString + ",CH3=" + intErr(3).ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' Trigger ModeR{{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' gK[hEOgK[h̑IB
    ''' </remarks>
    Private Sub ComboBoxTrigger_SelectionChangeCommitted(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxTrigger.SelectionChangeCommitted
        Dim Num As Integer
        Dim LastCH As Integer
        Try
            For Num = 0 To 3
                If (m_flgVideoOpened(Num) = True) Then
                    m_video(Num).Trigger = 2        'OgKɂ
                    LastCH = Num
                End If
            Next
            'gKw肳ĂꍇAŌ̃`l̂ݓgKɂB
            If (ComboBoxTrigger.SelectedIndex = 0) Then
                m_video(LastCH).Trigger = 1         'gKɂ
            End If
            'ЃLv`{[h̓gK[[h̐ݒɃZbgAbv^CKvɂȂ܂
            '{vÕZbgAbv^C͕Kvőlł350msݒ肵Ă܂B
            'Lv`{[hɂĂ̎Ԃ͈قȂ܂B
            Threading.Thread.Sleep(350)
        Catch ex As Exception
            'G[
            For Num = 0 To 3
                intErr(Num) = m_video(Num).ErrorCode
            Next
            MessageBox.Show("ErrorCode:CH0=" + intErr(0).ToString + ",CH1=" + intErr(1).ToString + ",CH2=" + intErr(2).ToString + ",CH3=" + intErr(3).ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' CH0 Offse NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ItZbg(CH0)̐ݒB
    ''' </remarks>
    Private Sub NumericUpDownCH0Offset_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownCH0Offset.ValueChanged
        Try
            If (m_flgVideoOpened(0) = True) Then
                '`lOɐݒ
                m_video(0).VideoOffset = NumericUpDownCH0Offset.Value
            End If
        Catch ex As Exception
            'G[
            intErr(0) = m_video(0).ErrorCode
            MessageBox.Show("ErrorCode:CH0= " + intErr(0).ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' CH1 Offset NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ItZbg(CH1)̐ݒB
    ''' </remarks>
    Private Sub NumericUpDownCH1Offset_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownCH1Offset.ValueChanged
        Try
            If (m_flgVideoOpened(1) = True) Then
                '`lPɐݒ
                m_video(1).VideoOffset = NumericUpDownCH1Offset.Value
            End If
        Catch ex As Exception
            'G[
            intErr(1) = m_video(1).ErrorCode
            MessageBox.Show("ErrorCode:CH1= " + intErr(1).ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' CH2 Offset NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ItZbg(CH2)̐ݒB
    ''' </remarks>
    Private Sub NumericUpDownCH2Offset_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownCH2Offset.ValueChanged
        Try
            If (m_flgVideoOpened(2) = True) Then
                '`lOɐݒ
                m_video(2).VideoOffset = NumericUpDownCH2Offset.Value
            End If
        Catch ex As Exception
            'G[
            intErr(2) = m_video(2).ErrorCode
            MessageBox.Show("ErrorCode:CH2= " + intErr(2).ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' CH3 Offset NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ItZbg(CH3)̐ݒB
    ''' </remarks>
    Private Sub NumericUpDownCH3Offset_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownCH3Offset.ValueChanged
        Try
            If (m_flgVideoOpened(3) = True) Then
                '`lPɐݒ
                m_video(3).VideoOffset = NumericUpDownCH3Offset.Value
            End If
        Catch ex As Exception
            'G[
            intErr(3) = m_video(3).ErrorCode
            MessageBox.Show("ErrorCode:CH3= " + intErr(3).ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' CH0 Exposure NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' JI(CH0)̐ݒB
    ''' </remarks>
    Private Sub NumericUpDownCH0Exposure_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownCH0Exposure.ValueChanged
        Try
            If (m_flgVideoOpened(0) = True) Then
                m_video(0).ExposureTime = NumericUpDownCH0Exposure.Value
            End If
        Catch ex As Exception
            'G[
            intErr(0) = m_video(0).ErrorCode
            MessageBox.Show("ErrorCode:CH1= " + intErr(0).ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' CH1 Exposure NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' JI(CH1)̐ݒB
    ''' </remarks>
    Private Sub NumericUpDownCH1Exposure_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownCH1Exposure.ValueChanged
        Try
            If (m_flgVideoOpened(1) = True) Then
                m_video(1).ExposureTime = NumericUpDownCH1Exposure.Value
            End If
        Catch ex As Exception
            'G[
            intErr(1) = m_video(1).ErrorCode
            MessageBox.Show("ErrorCode:CH1= " + intErr(1).ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' CH2 Exposure NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' JI(CH2)̐ݒB
    ''' </remarks>
    Private Sub NumericUpDownCH2Exposure_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownCH2Exposure.ValueChanged
        Try
            If (m_flgVideoOpened(2) = True) Then
                m_video(2).ExposureTime = NumericUpDownCH2Exposure.Value
            End If
        Catch ex As Exception
            'G[
            intErr(2) = m_video(2).ErrorCode
            MessageBox.Show("ErrorCode:CH2= " + intErr(2).ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' CH3 Exposure NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' JI(CH3)̐ݒB
    ''' </remarks>
    Private Sub NumericUpDownCH3Exposure_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownCH3Exposure.ValueChanged
        Try
            If (m_flgVideoOpened(3) = True) Then
                m_video(3).ExposureTime = NumericUpDownCH3Exposure.Value
            End If
        Catch ex As Exception
            'G[
            intErr(3) = m_video(3).ErrorCode
            MessageBox.Show("ErrorCode:CH3= " + intErr(3).ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' Binarize ComboBox
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' Ql@\̐ݒ
    ''' </remarks>
    Private Sub ComboBoxBinarize_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxBinarize.SelectedIndexChanged
        Dim Num As Integer
        Dim binarize As FVIL.Video.CFviVideoBinarize = New FVIL.Video.CFviVideoBinarize     '2lp[^\

        Try
            For Num = 0 To 3
                If (m_flgVideoOpened(Num) = True) Then
                    binarize.Threshold = m_video(Num).Binarize.Threshold
                    binarize.Mode = ComboBoxBinarize.SelectedIndex
                    'Ql@\̐ݒ
                    m_video(Num).Binarize = binarize
                    '捞摜𐳋K
                    m_video(Num).ChangeImageSize(m_image(Num))
                End If
            Next
        Catch ex As Exception
            'G[
            For Num = 0 To 3
                intErr(Num) = m_video(Num).ErrorCode
            Next
            MessageBox.Show("ErrorCode:CH0=" + intErr(0).ToString + ",CH1=" + intErr(1).ToString + ",CH2=" + intErr(2).ToString + ",CH3=" + intErr(3).ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' CH0 Threshold NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 2ll(CH0)̐ݒ
    ''' </remarks>
    Private Sub NumericUpDownCH0Threshold_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownCH0Threshold.ValueChanged
        Try
            If (m_flgVideoOpened(0) = True) Then
                Dim Binarize As FVIL.Video.CFviVideoBinarize = m_video(0).Binarize
                Binarize.Threshold = NumericUpDownCH0Threshold.Value
                '`lOɐݒ
                m_video(0).Binarize = Binarize
            End If
        Catch ex As Exception
            'G[
            intErr(0) = m_video(0).ErrorCode
            MessageBox.Show("ErrorCode:CH0= " + intErr(0).ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' CH1 Threshold NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 2ll(CH1)̐ݒ
    ''' </remarks>
    Private Sub NumericUpDownCH1Threshold_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownCH1Threshold.ValueChanged
        Try
            If (m_flgVideoOpened(1) = True) Then
                Dim Binarize As FVIL.Video.CFviVideoBinarize = m_video(1).Binarize
                Binarize.Threshold = NumericUpDownCH1Threshold.Value
                '`lPɐݒ
                m_video(1).Binarize = Binarize
            End If
        Catch ex As Exception
            'G[
            intErr(1) = m_video(1).ErrorCode
            MessageBox.Show("ErrorCode:CH1= " + intErr(1).ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' CH2 Threshold NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 2ll(CH2)̐ݒ
    ''' </remarks>
    Private Sub NumericUpDownCH2Threshold_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownCH2Threshold.ValueChanged
        Try
            If (m_flgVideoOpened(2) = True) Then
                Dim Binarize As FVIL.Video.CFviVideoBinarize = m_video(2).Binarize
                Binarize.Threshold = NumericUpDownCH2Threshold.Value
                '`lOɐݒ
                m_video(2).Binarize = Binarize
            End If
        Catch ex As Exception
            'G[
            intErr(2) = m_video(2).ErrorCode
            MessageBox.Show("ErrorCode:CH2= " + intErr(2).ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' CH3 Threshold NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 2ll(CH3)̐ݒ
    ''' </remarks>
    Private Sub NumericUpDownCH3Threshold_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownCH3Threshold.ValueChanged
        Try
            If (m_flgVideoOpened(3) = True) Then
                Dim Binarize As FVIL.Video.CFviVideoBinarize = m_video(3).Binarize
                Binarize.Threshold = NumericUpDownCH3Threshold.Value
                '`lPɐݒ
                m_video(3).Binarize = Binarize
            End If
        Catch ex As Exception
            'G[
            intErr(3) = m_video(3).ErrorCode
            MessageBox.Show("ErrorCode:CH3= " + intErr(3).ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' ReLoad Ini File{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' rfIݒpinit@C̍ĐݒB
    ''' </remarks>
    Private Sub ButtonReLoadIni_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonReLoadIni.Click
        't[Ȃ΁A~B
        If (m_flgFreerun = True) Then
            ButtonGrabContinue.Text = "Grab Continue"
            ButtonGrabOne.Enabled = True
            m_flgFreerun = False
            Timer1.Enabled = False
            Application.DoEvents()
        End If

        'init@CI
        fnSetIniFile()

    End Sub

    ''' <summary>
    ''' Save Image{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' \摜ۑ
    ''' </remarks>
    Private Sub ButtonSaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSaveImage.Click
        Dim ofdlg As SaveFileDialog = New SaveFileDialog()
        ofdlg.Filter = "摜t@C(*.bmp;*.dib;*.png;*.jpg;*.jpeg;*.tif;*.tiff;*.raw;*.pat)|*.bmp;*.dib;*.png;*.jpg;*.jpeg;*.tif;*.tiff;*.raw;*.pat"
        ofdlg.Filter += "|Bitmap t@C (*.bmp;*.dib)|*.bmp;*.dib"
        ofdlg.Filter += "|Png t@C (*.png)|*.png"
        ofdlg.Filter += "|Jpeg t@C (*.jpg;*.jpeg)|*.jpg;*.jpeg"
        ofdlg.Filter += "|Tiff t@C (*.tif;*.tiff)|*.tif;*.tiff"
        ofdlg.Filter += "|Raw t@C (*.raw)|*.raw"
        ofdlg.Filter += "|ׂẴt@C (*.*)|*.*"
        ofdlg.OverwritePrompt = True

        Try
            If (ofdlg.ShowDialog(Me) = Windows.Forms.DialogResult.OK) Then
                Dim name As String
                Dim temp As Integer
                'gq܂ł̕Zo
                temp = ofdlg.FileName.Length - ofdlg.FileName.LastIndexOfAny(".")
                temp = ofdlg.FileName.Length - temp

                '̊֐́AȈՓIɉ摜t@C̕ۑŝׂ̂łB 
                '̊֐ŎwłȂp[^w肷Kv΁A e摜t@CANZXNX𒼐ڎgpĂB 

                '`lỎ摜ۑ
                If (m_flgVideoOpened(0) = True) Then
                    name = ofdlg.FileName.Insert(temp, "_CH0")
                    FVIL.File.Function.SaveImageFile(name, CFviImageViewCH0.Image)
                End If
                '`lP̉摜ۑ
                If (m_flgVideoOpened(1) = True) Then
                    name = ofdlg.FileName.Insert(temp, "_CH1")
                    FVIL.File.Function.SaveImageFile(name, CFviImageViewCH1.Image)
                End If
                '`lQ̉摜ۑ
                If (m_flgVideoOpened(2) = True) Then
                    name = ofdlg.FileName.Insert(temp, "_CH2")
                    FVIL.File.Function.SaveImageFile(name, CFviImageViewCH2.Image)
                End If
                '`lR̉摜ۑ
                If (m_flgVideoOpened(3) = True) Then
                    name = ofdlg.FileName.Insert(temp, "_CH3")
                    FVIL.File.Function.SaveImageFile(name, CFviImageViewCH3.Image)
                End If

                'ۑt@C`Œ̏ꍇ́Aȉ̂悤ɋLq܂B
                '1) bmpt@C̏ꍇ
                'Dim file As FVIL.File.CFviImageFileBmp = New FVIL.File.CFviImageFileBmp()
                'file.Save(ofdlg.FileName, m_image)

                '2) jpgt@C̏ꍇ
                'Dim file As FVIL.File.CFviImageFileJpg = New FVIL.File.CFviImageFileJpg()
                'file.Save(ofdlg.FileName, m_image)
            End If
        Catch ex As FVIL.CFviException
            Dim msg As System.String = System.String.Format("CuO𔭍s܂Bcode={0} func={1}", ex.ErrorCode, ex.Function)
            Select Case (ex.ErrorCode)
                Case FVIL.ErrorCode.NOT_SUPPORTED, _
                 FVIL.ErrorCode.INVALID_OBJECT
                    msg += vbCrLf + "T|[gĂȂ摜IuWFNgłB"
                    msg += vbCrLf + "Raw `ŕۑĂB"
            End Select
            MessageBox.Show(msg, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' x1{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' {ŕ\܂B
    ''' </remarks>
    Private Sub ButtonMag1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMag1.Click
        '摜̕\{̎擾܂͐ݒs܂B1.0Ǝw肷Ɠ{ŕ\܂B
        '{ĺA0.5Ƃꍇ́AE1/2ƂȂAʐς1/4ɂȂ܂B
        '3.0Ƃꍇ́AE3{ƂȂAʐς9{ɂȂ܂B
        '\{̐ݒ
        CFviImageViewCH0.Display.Magnification = 1.0
        CFviImageViewCH1.Display.Magnification = 1.0
        CFviImageViewCH2.Display.Magnification = 1.0
        CFviImageViewCH3.Display.Magnification = 1.0
        'ĕ`
        CFviImageViewCH0.Refresh()
        CFviImageViewCH1.Refresh()
        CFviImageViewCH2.Refresh()
        CFviImageViewCH3.Refresh()

    End Sub

    ''' <summary>
    ''' Fit{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 摜Ŝr[̃NCAg̈ɕ\ł悤ɕ\{k(܂͊g)܂
    ''' </remarks>
    Private Sub ButtonFit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonFit.Click
        '摜Ŝr[̃NCAg̈ɕ\ł悤ɕ\{k(܂͊g)܂
        '\{𒲐
        CFviImageViewCH0.FitImageSize()
        CFviImageViewCH1.FitImageSize()
        CFviImageViewCH2.FitImageSize()
        CFviImageViewCH3.FitImageSize()
        'ĕ`
        CFviImageViewCH0.Refresh()
        CFviImageViewCH1.Refresh()
        CFviImageViewCH2.Refresh()
        CFviImageViewCH3.Refresh()

    End Sub

    ''' <summary>
    ''' {{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ݂̔{0.5{ŕ\܂B
    ''' </remarks>
    Private Sub ButtonPlus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonPlus.Click
        Dim Value As Double
        '{̎擾
        Value = CFviImageViewCH0.Display.Magnification
        '\{̐ݒ
        Value = Value + 0.5
        CFviImageViewCH0.Display.Magnification = Value
        CFviImageViewCH1.Display.Magnification = Value
        CFviImageViewCH2.Display.Magnification = Value
        CFviImageViewCH3.Display.Magnification = Value
        'ĕ`
        CFviImageViewCH0.Refresh()
        CFviImageViewCH1.Refresh()
        CFviImageViewCH2.Refresh()
        CFviImageViewCH3.Refresh()

    End Sub

    ''' <summary>
    ''' |{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ݂̔{0.5{ŕ\܂BA{OȉɂȂꍇ͔{0.1ŕ\܂B
    ''' </remarks>
    Private Sub ButtonMinus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMinus.Click
        Dim Value As Double
        '{̎擾
        Value = CFviImageViewCH0.Display.Magnification
        '\{̐ݒ
        Value = Value - 0.5
        If (Value <= 0) Then
            Value = 0.1       'Oȉݒ肷ƃG[ɂȂ̂0.1ݒ肷
        End If
        CFviImageViewCH0.Display.Magnification = Value
        CFviImageViewCH1.Display.Magnification = Value
        CFviImageViewCH2.Display.Magnification = Value
        CFviImageViewCH3.Display.Magnification = Value
        'ĕ`
        CFviImageViewCH0.Refresh()
        CFviImageViewCH1.Refresh()
        CFviImageViewCH2.Refresh()
        CFviImageViewCH3.Refresh()

    End Sub

    ''' <summary>
    ''' Ascope`FbN{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ASCOPE̕\ؑւ܂B
    ''' </remarks>
    Private Sub CheckBoxAScope_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxAscope.CheckedChanged
        'ASCOPEI[oC̐ݒ
        If (CheckBoxAscope.CheckState) Then
            'ASCOPE̕\LɂB
            CFviImageViewCH0.Display.OverlayAscope.Enable = True
            CFviImageViewCH0.Display.OverlayAscope.Active = True
            CFviImageViewCH1.Display.OverlayAscope.Enable = True
            CFviImageViewCH1.Display.OverlayAscope.Active = True
            CFviImageViewCH2.Display.OverlayAscope.Enable = True
            CFviImageViewCH2.Display.OverlayAscope.Active = True
            CFviImageViewCH3.Display.OverlayAscope.Enable = True
            CFviImageViewCH3.Display.OverlayAscope.Active = True
        Else
            'ASCOPE̕\𖳌ɂB
            CFviImageViewCH0.Display.OverlayAscope.Enable = False
            CFviImageViewCH0.Display.OverlayAscope.Active = False
            CFviImageViewCH1.Display.OverlayAscope.Enable = False
            CFviImageViewCH1.Display.OverlayAscope.Active = False
            CFviImageViewCH2.Display.OverlayAscope.Enable = False
            CFviImageViewCH2.Display.OverlayAscope.Active = False
            CFviImageViewCH3.Display.OverlayAscope.Enable = False
            CFviImageViewCH3.Display.OverlayAscope.Active = False
        End If
        'ĕ`
        CFviImageViewCH0.Refresh()
        CFviImageViewCH1.Refresh()
        CFviImageViewCH2.Refresh()
        CFviImageViewCH3.Refresh()

    End Sub

End Class
